<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '主键',
    component: 'Input',
    hidden: true
  },{
    field: 'custCode',
    label: '客户号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'createOrgancode',
    label: '创建机构',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'createReason',
    label: '创建原因',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'opBy',
    label: '操作员',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'opDate',
    label: '操作日期',
    component: 'DatePicker',
    componentProps: {
      type: 'daterange'
    },
  },
  {
    field: 'unlockStatus',
    label: '解除状态',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'unlockReason',
    label: '解除原因',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'unlockBy',
    label: '解除人',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'unlockDate',
    label: '解除日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'statusNo',
    label: '状态',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'custName',
    label: '客户名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'custType',
    label: '客户类型',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

